##
# This code was generated by
# \ / _    _  _|   _  _
#  | (_)\/(_)(_|\/| |(/_  v1.0.0
#       /       /
# 
# frozen_string_literal: true

require 'spec_helper.rb'

describe 'Notification' do
  it "can create" do
    @holodeck.mock(Twilio::Response.new(500, ''))

    expect {
      @client.notify.v1.services('ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX') \
                       .notifications.create()
    }.to raise_exception(Twilio::REST::TwilioError)

    values = {}
    expect(
    @holodeck.has_request?(Holodeck::Request.new(
        method: 'post',
        url: 'https://notify.twilio.com/v1/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Notifications',
    ))).to eq(true)
  end

  it "receives create responses" do
    @holodeck.mock(Twilio::Response.new(
        201,
      %q[
      {
          "sid": "NOb8021351170b4e1286adaac3fdd6d082",
          "account_sid": "ACaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
          "service_sid": "IS699b53e02da45a1ba9d13b7d7d2766af",
          "date_created": "2016-03-24T23:42:28Z",
          "identities": [
              "jing"
          ],
          "tags": [],
          "segments": [],
          "priority": "high",
          "ttl": 2419200,
          "title": "test",
          "body": "body",
          "sound": null,
          "action": null,
          "data": null,
          "apn": null,
          "fcm": null,
          "gcm": null,
          "sms": null,
          "facebook_messenger": null,
          "alexa": null
      }
      ]
    ))

    actual = @client.notify.v1.services('ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX') \
                              .notifications.create()

    expect(actual).to_not eq(nil)
  end

  it "receives create_direct_notification responses" do
    @holodeck.mock(Twilio::Response.new(
        201,
      %q[
      {
          "sid": "NOb8021351170b4e1286adaac3fdd6d082",
          "account_sid": "ACaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
          "service_sid": "IS699b53e02da45a1ba9d13b7d7d2766af",
          "date_created": "2016-03-24T23:42:28Z",
          "identities": [],
          "tags": [],
          "segments": [],
          "priority": "high",
          "ttl": 2419200,
          "title": null,
          "body": "body",
          "sound": null,
          "action": null,
          "data": null,
          "apn": null,
          "fcm": null,
          "gcm": null,
          "sms": null,
          "facebook_messenger": null,
          "alexa": null
      }
      ]
    ))

    actual = @client.notify.v1.services('ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX') \
                              .notifications.create()

    expect(actual).to_not eq(nil)
  end
end