##
# This code was generated by
# \ / _    _  _|   _  _
#  | (_)\/(_)(_|\/| |(/_  v1.0.0
#       /       /
# 
# frozen_string_literal: true

require 'spec_helper.rb'

describe 'Day' do
  it "can read" do
    @holodeck.mock(Twilio::Response.new(500, ''))

    expect {
      @client.preview.bulk_exports.exports('resource_type') \
                                  .days.list()
    }.to raise_exception(Twilio::REST::TwilioError)

    values = {}
    expect(
    @holodeck.has_request?(Holodeck::Request.new(
        method: 'get',
        url: 'https://preview.twilio.com/BulkExports/Exports/resource_type/Days',
    ))).to eq(true)
  end

  it "receives read responses" do
    @holodeck.mock(Twilio::Response.new(
        200,
      %q[
      {
          "days": [
              {
                  "day": "2017-05-01",
                  "size": 1234,
                  "resource_type": "Calls"
              }
          ],
          "meta": {
              "key": "days",
              "page_size": 50,
              "url": "https://preview.twilio.com/BulkExports/Exports/Calls/Days?PageSize=50&Page=0",
              "page": 0,
              "first_page_url": "https://preview.twilio.com/BulkExports/Exports/Calls/Days?PageSize=50&Page=0",
              "previous_page_url": null,
              "next_page_url": null
          }
      }
      ]
    ))

    actual = @client.preview.bulk_exports.exports('resource_type') \
                                         .days.list()

    expect(actual).to_not eq(nil)
  end
end